"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// TODO: Move to serparate component
/** Adapted from https://github.com/streamich/react-use/blob/master/src/useAsyncFn.ts */
const react_1 = require("react");
const useMountedState_1 = __importDefault(require("react-use/lib/useMountedState"));
function useAsyncFnReset(fn, deps = [], initialState = { loading: false }) {
    const lastCallId = (0, react_1.useRef)(0);
    const isMounted = (0, useMountedState_1.default)();
    const [state, set] = (0, react_1.useState)(initialState);
    const callback = (0, react_1.useCallback)((...args) => {
        const callId = ++lastCallId.current;
        if (!state.loading) {
            set((prevState) => (Object.assign(Object.assign({}, prevState), { loading: true })));
        }
        return fn(...args).then((value) => {
            isMounted() && callId === lastCallId.current && set({ value, loading: false });
            return value;
        }, (error) => {
            isMounted() && callId === lastCallId.current && set({ error, loading: false });
            return error;
        });
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, deps);
    const resetState = (0, react_1.useCallback)(() => {
        set(initialState);
    }, [initialState]);
    return [state, callback, resetState];
}
exports.default = useAsyncFnReset;
//# sourceMappingURL=use-async-fn-reset.js.map