"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncTestAutoSaveNew = exports.AsyncTestSaveAll = exports.AsyncTestLoadOnInit = exports.AsyncTestNewObject = exports.AsyncTest = void 0;
/* eslint-disable indent */
/* eslint-disable react/jsx-indent */
/* eslint-disable react/jsx-one-expression-per-line */
/* eslint-disable no-unused-vars */
/* eslint-disable react/prop-types */
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const demo_data_1 = require("./demo-data");
const use_async_object_manager_1 = require("./use-async-object-manager");
const cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
const test_utils_1 = require("./test-utils");
const defaultArgs = {
    activeUid: demo_data_1.demoLoadedData.uid,
    collection: 'demoCollection',
    isNew: false,
    inputAdditionalData: demo_data_1.inputAdditionalData,
    schema: 'all',
    loadOnInit: false,
    asyncGetDocument: () => __awaiter(void 0, void 0, void 0, function* () { return ({}); }),
    asyncPutDocument: () => __awaiter(void 0, void 0, void 0, function* () { return ({ ok: true }); }),
    asyncPostDocument: () => __awaiter(void 0, void 0, void 0, function* () { return ({ ok: true }); }),
    asyncDeleteDocument: () => __awaiter(void 0, void 0, void 0, function* () { return ({ ok: true }); }),
};
const defaultArgsNew = Object.assign(Object.assign({}, defaultArgs), { isNew: true, activeUid: undefined });
const sleep = (delay) => new Promise((res) => {
    setTimeout(function () {
        res();
    }, delay);
});
const Viz = ({ loadedData, saveData, updateData, updateField, resetData, reload, deleteObject, saveResponse, deleteResponse, loadingData, savingData, deletingData, data, isNew, uid, callCount, dbData, asyncGetDocument, asyncPutDocument, asyncPostDocument, asyncDeleteDocument, saveError, onSavedCallbackResponse, saveErrorCallbackResponse, onDeleteCallbackResponse, }) => {
    var _a;
    return (react_1.default.createElement("div", null,
        uid,
        react_1.default.createElement("button", { type: "button", className: "button-one", onClick: reload }, "Reload data"),
        react_1.default.createElement("div", null, loadingData ? 'loading data' : 'Loaded data'),
        react_1.default.createElement("div", null,
            "Loaded data:",
            react_1.default.createElement("span", { "data-testid": "loadedData" }, (0, test_utils_1.JSONStringifySorted)(loadedData))),
        react_1.default.createElement("div", null,
            "data:",
            react_1.default.createElement("span", { "data-testid": "data" }, (0, test_utils_1.JSONStringifySorted)(data))),
        react_1.default.createElement("div", null,
            "Callcount: ",
            react_1.default.createElement("span", { "data-testid": "callcount" }, callCount)),
        react_1.default.createElement("div", null,
            "Is New: ",
            react_1.default.createElement("span", { "data-testid": "isnew" }, isNew ? 'true' : 'false')),
        react_1.default.createElement("p", null,
            react_1.default.createElement("label", { htmlFor: "goodbyeInput" }, "Goodbye Input"),
            react_1.default.createElement("input", { id: "goodbyeInput", onChange: (e) => updateField('goodbye', e.target.value, false), value: (data === null || data === void 0 ? void 0 : data.goodbye) || '' })),
        react_1.default.createElement("p", null,
            react_1.default.createElement("button", { onClick: () => saveData() }, "Save")),
        react_1.default.createElement("div", null,
            react_1.default.createElement("h1", null, "Db data"),
            react_1.default.createElement("p", { "data-testid": "dbData" }, JSON.stringify(dbData))),
        react_1.default.createElement("div", null,
            react_1.default.createElement("h1", null, "Db overrides"),
            react_1.default.createElement("p", null,
                react_1.default.createElement("label", { htmlFor: "goodbyeInputDb" }, "Goodbye Input Db"),
                react_1.default.createElement("input", { id: "goodbyeInputDb", onChange: (e) => {
                        asyncPostDocument('demoCollection', demo_data_1.demoLoadedData.uid, Object.assign(Object.assign({}, dbData.demoCollection[demo_data_1.demoLoadedData.uid]), { goodbye: e.target.value }));
                    }, value: ((_a = dbData.demoCollection[demo_data_1.demoLoadedData.uid]) === null || _a === void 0 ? void 0 : _a.goodbye) || '' }))),
        react_1.default.createElement("div", null,
            react_1.default.createElement("h1", null, "Responses"),
            react_1.default.createElement("div", null,
                react_1.default.createElement("p", { "data-testid": "saveResponse" }, (saveResponse === null || saveResponse === void 0 ? void 0 : saveResponse.ok) || JSON.stringify(saveResponse)),
                react_1.default.createElement("p", { "data-testid": "saveError" }, saveError && saveError.message))),
        react_1.default.createElement("div", null,
            react_1.default.createElement("h1", null, "Callbacks"),
            onSavedCallbackResponse && (react_1.default.createElement("p", { "data-testid": "onSavedCallbackResponse" }, JSON.stringify(onSavedCallbackResponse))),
            saveErrorCallbackResponse && (react_1.default.createElement("p", { "data-testid": "saveErrorCallbackResponse" }, saveErrorCallbackResponse.message || 'UNKNOWN ERROR')),
            onDeleteCallbackResponse && (react_1.default.createElement("p", { "data-testid": "onDeleteCallbackResponse" }, JSON.stringify(onDeleteCallbackResponse))))));
};
const useDemoDatabase = () => {
    const [data, setData] = react_1.default.useState((0, cloneDeep_1.default)(demo_data_1.demoDbData));
    const asyncGetDocument = (collection, uid) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        return data[collection][uid];
    });
    const asyncPutDocument = (collection, uid, objData) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        if (objData.goodbye === 'ERROR') {
            throw new Error('You asked for an error?');
        }
        setData((prev) => (Object.assign(Object.assign({}, prev), { [collection]: Object.assign(Object.assign({}, prev[collection]), { [uid]: Object.assign(Object.assign({}, prev[collection][uid]), objData) }) })));
        return { ok: true };
    });
    const asyncPostDocument = (collection, uid, newData) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        setData((prev) => (Object.assign(Object.assign({}, prev), { [collection]: Object.assign(Object.assign({}, prev[collection]), { [uid]: newData }) })));
        return { ok: true };
    });
    const asyncDeleteDocument = (collection, uid) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        setData((prev) => (Object.assign(Object.assign({}, prev), { [collection]: Object.assign(Object.assign({}, prev[collection]), { [uid]: undefined }) })));
        return { ok: true };
    });
    return {
        dbData: data,
        asyncGetDocument,
        asyncPutDocument,
        asyncPostDocument,
        asyncDeleteDocument,
    };
};
const useHandleCallbacks = () => {
    const [onSavedCallbackResponse, setonSavedCallbackResponse] = react_1.default.useState(null);
    const [saveErrorCallbackResponse, setsaveErrorCallbackResponse] = react_1.default.useState(null);
    const [onDeleteCallbackResponse, setonDeleteCallbackResponse] = react_1.default.useState(null);
    const onSavedCallback = (uid, response, combinedData) => {
        setsaveErrorCallbackResponse(null);
        setonSavedCallbackResponse([uid, response, combinedData]);
    };
    const saveErrorCallback = (e) => {
        setonSavedCallbackResponse(null);
        setsaveErrorCallbackResponse(e);
    };
    const onDeleteCallback = (e) => {
        setonDeleteCallbackResponse(e);
    };
    return {
        onSavedCallback,
        saveErrorCallback,
        onDeleteCallback,
        onSavedCallbackResponse,
        saveErrorCallbackResponse,
        onDeleteCallbackResponse,
    };
};
const AsyncTest = () => {
    const handleCallbacks = useHandleCallbacks();
    const database = useDemoDatabase();
    const asyncOut = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign(Object.assign({}, defaultArgs), database), handleCallbacks));
    return react_1.default.createElement(Viz, Object.assign({}, asyncOut, database, handleCallbacks));
};
exports.AsyncTest = AsyncTest;
exports.AsyncTest.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () { });
const AsyncTestNewObject = () => {
    const handleCallbacks = useHandleCallbacks();
    const database = useDemoDatabase();
    const asyncOut = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign(Object.assign(Object.assign({}, defaultArgsNew), { inputAdditionalData: demo_data_1.inputAdditionalData }), database), handleCallbacks));
    return react_1.default.createElement(Viz, Object.assign({}, asyncOut, database, handleCallbacks));
};
exports.AsyncTestNewObject = AsyncTestNewObject;
exports.AsyncTestNewObject.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () { });
const AsyncTestLoadOnInit = () => {
    const handleCallbacks = useHandleCallbacks();
    const database = useDemoDatabase();
    const asyncOut = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign(Object.assign(Object.assign({}, defaultArgs), database), { loadOnInit: true }), handleCallbacks));
    return react_1.default.createElement(Viz, Object.assign({}, asyncOut, database, handleCallbacks));
};
exports.AsyncTestLoadOnInit = AsyncTestLoadOnInit;
exports.AsyncTestLoadOnInit.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () {
    yield react_2.screen.findByText('Loaded data');
});
const AsyncTestSaveAll = () => {
    const handleCallbacks = useHandleCallbacks();
    const database = useDemoDatabase();
    const asyncOut = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign(Object.assign(Object.assign({}, defaultArgs), database), { loadOnInit: true, saveAllOnSave: true }), handleCallbacks));
    return react_1.default.createElement(Viz, Object.assign({}, asyncOut, database, handleCallbacks));
};
exports.AsyncTestSaveAll = AsyncTestSaveAll;
exports.AsyncTestSaveAll.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () {
    yield react_2.screen.findByText('Loaded data');
});
const AsyncTestAutoSaveNew = () => {
    const handleCallbacks = useHandleCallbacks();
    const database = useDemoDatabase();
    const asyncOut = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, defaultArgsNew), { inputAdditionalData: demo_data_1.inputAdditionalData }), database), handleCallbacks), { autoSaveNew: true }));
    return react_1.default.createElement(Viz, Object.assign({}, asyncOut, database, handleCallbacks));
};
exports.AsyncTestAutoSaveNew = AsyncTestAutoSaveNew;
exports.AsyncTestAutoSaveNew.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () {
    yield react_2.screen.findByText('Loaded data');
    yield (0, react_2.waitFor)(() => expect(react_2.screen.getByTestId('dbData').textContent).toContain(demo_data_1.inputAdditionalData.injectedProp));
});
//# sourceMappingURL=use-async-object-manager.composition.js.map